jxWebUI使用表格来进行各控件的行列对齐，这样的表称为容器表。

## 定义格式

容器表的定义格式为：

	table 表名 属性列表 : 行+ ;

属性列表见整体说明中的额外说明部分。

行：

	row 
		本行的各web组件定义

如：

	table table1 title='查询条件',width=900:
		row
			text text1 text='设备类型',bind=text1,width=200
			input input1 bind=devType,width=200
		row
			text text2 text='设备名',width=200
			input input2 bind=devName,width=200
		row
			button button1 text='查询',width=100,motion=cmd,demand=reSearch
	;

定义的就是下图中的查询条件表，有三行，第一行是一个设备类型的文本和一个输入框，第二行是一个设备名的文本和一个输入框，第三行是一个查询按钮。

![test_web](http://115.29.52.95:10018/images/dt_1.png)

<font color=red size=3>注1：</font>表的定义必须以英文分号结束

<font color=red size=3>注2：</font>冒号、分号都是英文的，不要用错了
## 属性

### title
类型：string
缺省值：

表的标题。

### header
类型：bool
缺省值：true

是否显示表头。表头包括：标题【左侧】、添加新行的按钮【右侧】。

你现在正在看的页面就是没有表头的显示效果。

### width
类型：int
缺省值：

表的宽度。笔者当时是按1280来设计的，所以表宽一般设为900。
### alone
类型：bool
缺省值：false

每一行是否独立。

我们反复说了，容器表是用来进行行列对齐的。但有的表会非常复杂，某一个控件要求的宽度可能会非常宽，根本无法和其它控件进行列对齐。

但这种情况下如果拆分成两个表的话，又可能会破坏界面表达的逻辑性。

针对这种情况，jxWebUI提供了alone属性。定义了alone=true的容器表，每一行都是独立的，只根据本行所有控件的width数值进行布局。这样就可以灵活的定义各个控件的宽度了。

<font color=red size=3>注1：</font>当定义了alone=true后，如果某两行中各控件的宽度定义都是一致的，那么这两行看上去的效果还是对齐的

<font color=red size=3>注2：</font>当定义了alone=true后，如果某一行中只定义了一个控件，拿这个控件就会占据整行

下图就是同样的控件布局，未设置alone和设置了alone=true的显示效果对比：

![hello_world](http://115.29.52.95:10018/images/rqb_1.png)

通过上图我们可以看出：表宽是由每一行中的各控件，根据各自的width属性大小来平分的。所以才会出现下一个中按钮1独占了一行，第二行两个width相同的空间平分了第二行。

所以，宽度并非绝对量，而是根据各控件的width属性在所有控件的width总和的占比来分配各控件的实际宽度的。
