在jxWebUI中，用户可以同时打开多个界面，每个界面在tabs占据一个tab。我们定义的所有page都必须显示到一个tab中。

但一个tab只能有一个主page，同时还可以有多个附属的page，也就是对话框。

更本质一点，一个tab就对应一个capaInstance。

所以，两个不同的tab中的page，哪怕都是打开的同一个capa中的page，但实际上它们对应的却是不同的capaInstance，所以可以有不同的输入输出。

那么，由于对话框是和主page显示在同一个tab中的，所以对话框就和主page共享了同一个capaInstance，也就是有相同的输出输出，进一步的，对话框中的操作可以修改主page中的web控件的显示。而不同tab是不可以修改其它tab中的web控件的。

## 定义格式

对话框page也是通过capa.page修饰符修饰的，也是定义了容器表。其和主page的区别，主要包括三点：

1、指定一个对话框确认按钮的绑定

2、定义一个工具条来实现确认按钮的点击定义

3、对话框的大小只有600

示例：

	okBtn='addMatch_Points_Btn'
	table table_dialog_test title='对话框111',width=600:
		row
			text text1 text='对话框文本框1',bind=text1,width=200
			input dialog_test_input1 bind=input11,width=200
	;
	web: a addMatch_Points_Btn width=80,text='添加',motion=cmd,demand=test1,hide=true,confirm='确认添加命中条件？' ;

显示效果：

![test_web](http://115.29.52.95:10018/images/dhk_1.png)

可以看出：

1、在通常的容器表定义之上多了一个okBtn=addMatch_Points_Btn的属性

2、而在容器表定义结束之后，又多了一个独立的web控件定义：addMatch_Points_Btn

通过这两步，其实就相当于把按钮【确认】的点击关联到了addMatch_Points_Btn这个工具条的触发事件上了。

而由于addMatch_Points_Btn定义了motion和demand属性，所以点击确认按钮，就相当于触发了：cmd.test1事件，等价于调用了用capa.event修饰的test1函数。

所以，对话框的定义包括三个部分：

	page属性：okBtn=工具条名
	本对话框的主体容器表的定义
	工具条的定义，需要注意的是其必须有一个hide=true的属性定义

hide=true也就是这个工具条不显示，所以其纯粹就是一个工具条:)就是用来代理确认按钮的点击功能的。大家可以去掉hide=true来看看实际效果。

这里的工具条就是一个单独的web控件定义，前面说过了：web控件都应定义到容器表中，但之所以还是提供了独立的web控件定义语法，就是给对话框所用的。

独立web控件的定义语法为：

	web: 控件定义 ;

控件定义参考整体说明中的额外说明部分，以及工具条的具体说明。