jxWebUI中的web组件都是通过文本进行定义的，定义语句放入capa.page修饰符进行修饰的函数的doc中，如：

	@capa.page
	def hello_world(ci, db, ctx):
	    '''
	        table table_hello_world width=900:
	            row
	                text text_hello_world text='hello_world',bind=text_hello_world,width=200
	        ;
	    '''
	    jxWebLogger.info(f'Hello world!')

上述代码定义了一个hello_world的page，然后就可以通过各种入口让用户点击后打开了。

一个page可以有一条或多条定义语句，每条语句必须以**英文分号**结束。

一个page包含的定义语句有四种：table、dataTable、单独的web定义语句、compute语句。

### table

table是容器表，也就是利用表的行列齐整的特点，用来将其它web组件整整齐齐显示用的。

table定义的详细说明请参考：容器表。

### dataTable

dataTable是数据表，是重要的数据显示手段。

dataTable在jxWebUI中有两大类：

- 主要用于显示查询结果的**条件查询分页显示**的数据表
- 同时完成表格数据的录入与显示的输入输出数据表

在jxWebUI中区分这两种数据表的根据就是看dataTable在定义时是否指定了属性：pagination。定义了pagination=true的就是查询表，没定义的就是输入输出表。

dataTable的详细说明请参考：数据表与数据库访问、用数据表查询数据、用数据表输入输出数据等。

### web语句

由于单独的web组件没有对齐等布局排布，所有原则上不应该将单独的web组件直接定义在page中。

而之所以要保留在page可以直接定义单独的web语句的原则，就在于对话框的定义需要。

所以，请牢记：除了对话框，其它page都不应该直接定义单独的web组件，而应该使用容器表来容纳web组件。

### compute

compute是联动计算的定义，详见前端联动计算。

### 数据装订

很多时候，我们在打开一个页面后，都需要对页面进行初始的数据装订。这个初始化工作就是在page修饰符所修饰的函数来完成的，上面hello_world的函数体中有如下的代码：

	jxWebLogger.info(f'Hello world!')

则在打开hello_world页面后，可以在日志中观察到一个输出：Hello world!

### 额外说明

1、所有web组件都必须有一个唯一名【同一capa】

2、除特别指出外【table、dataTable】，其它web组件都具有统一的格式：

	类型 控件名 属性列表

属性列表是由英文逗号分隔的等式：

	属性名 = 属性值

如：
	#文本
	text text_demo text='设备类型',bind=text_var,width=200
	#输入框
	input input_demo bind=devType,width=200

3、定义时所用的各种符合，如逗号、冒号、分号等都是英文的，不要用错了