权限管理本质上就是【用户-操作】映射表的建立与查询。而在jxWebUI中就更简单了：**当前的登录用户能否看到操作的入口**。

能看到某操作的入口，自然就能点击该入口向jxWebUI发起miton请求。看不到，自然就无法发起motion请求。

复习一下，jxWebUI中有四种入口：

- 快捷栏目录
- 用户按钮
- 数据表中的用户按钮
- 工具条菜单中的工具条

其中2、3的用户按钮，都是随page出现而出现，属于固有操作。因此，jxWebUI中对权限的管理主要就是登录用户能在快捷栏中和打开的各page的工具栏中能看到什么。

## 快捷栏

快捷栏属于全局性入口，在用户登录后一次性生成，在用户登录期间变。如果此时用户权限发生了变化，就需要登出然后再次登录。

给快捷栏添加授权对象非常简单：

	capa.shortCutTree_add_item(folder, label, demand, **authority='common'**, **attrs)

只要在定义快捷栏时指定authority属性即可。

## 工具条

工具条属于局部性入口，在用户打开一个主page时，从该page所有关联的工具条中进行权限匹配后生成。如果用户权限发生了变化，只要重新打开该page即可。

给工具条添加授权对象非常简单：

	capa.btn_list_add(page, motion, demand, authority='common', **attrs)

只要在关联page和工具条时指定authority属性即可。

## 权限检查

在生成快捷栏和工具栏时，jxWebUI会执行当前用户的权限检查，也就是从所有入口中按如下次序筛选：

1、先以当前登录用户的abbr【简称】作为authority进行筛选

2、然后以当前登录用户的roles【角色列表】中的每个角色作为authority进行筛选

3、最后用common作为authority进行筛选

然后把这三步所有筛选出的入口汇总后发到浏览器中动态生成快捷栏或工具栏。

这三步分别意为：专门指定给当前用户的操作、当前用户分配到的岗位职责所对应的所有操作、所有公共的操作。

## 特别说明

理论上权限检查应该越靠近操作越好，所以jxWebUI目前所采取的通过控制入口可见性来实现权限检查的做法，理论上是存在安全隐患的。

由于jxWebUI目前主要关注的是webUI的核心功能，安全问题不是关注的重点，所以暂不考虑增加调用前的权限检查。





